/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Julien
 *   Co-authors:
 *      
 *
 */

/**
    @file SOBFlagstone.cc
    @brief The flagstone, as described in the h file
*/

#include "SOBFlagstone.h"

#include "core/CoreIncludes.h"
#include "core/XMLPort.h"
#include "SOBFigure.h"
#include "util/Output.h"


namespace orxonox
{
    RegisterClass(SOBFlagstone);

    SOBFlagstone::SOBFlagstone(Context* context) : StaticEntity(context)
    {
        RegisterObject(SOBFlagstone);

        setAngularFactor(0.0);
        this->enableCollisionCallback();
        
        hasCollided_=false;
        
        
    }

    

    void SOBFlagstone::XMLPort(Element& xmlelement, XMLPort::Mode mode)
    {
        SUPER(SOBFlagstone, XMLPort, xmlelement, mode);
        XMLPortParam(SOBFlagstone, "points", setPoints, getPoints, xmlelement, mode);


    }

    
    bool SOBFlagstone::collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint) {

        return true;
    }


    


    
}
